#ifndef GFXTRACKBALL_INCLUDED // -*- C++ -*-
#define GFXTRACKBALL_INCLUDED
#if !defined(__GNUC__)
#  pragma once
#endif

/************************************************************************

  Virtual trackball rotation control.
  
  $Id: trackball.h,v 1.5 2001/03/06 16:11:14 garland Exp $

 ************************************************************************/

#include "quat.h"

extern void trackball(Quat& q, float p1x, float p1y, float p2x, float p2y);

class Trackball
{
public:
    Vec3f ctr;		// Describes a bounding sphere of object
    float radius;

    Vec3 trans;		// Translation of object
    Quat curquat;
    Quat lastquat;

    Trackball();

    void bounding_sphere(float cx, float cy, float cz, float r);
    void bounding_sphere(const Vec3f& v, float r);
    void bounding_sphere(const Vec3& v, double r);

    virtual void update_animation();
    virtual bool mouse_down(int *where, int which);
    virtual bool mouse_up(int *where, int which);
    virtual bool mouse_drag(int *where, int *last, int which);

    virtual void apply_transform();
    virtual void unapply_transform();
};

// GFXTRACKBALL_INCLUDED
#endif
